Package com.trilead.ssh2.crypto.cipher

# Class AES

java.lang.Object
com.trilead.ssh2.crypto.cipher.AES

All Implemented Interfaces:
  `BlockCipher`

public class AES extends Object implements BlockCipher
An implementation of the AES (Rijndael), from FIPS-197.

For further details see: http://csrc.nist.gov/encryption/aes/ . This implementation is based on optimizations from Dr. Brian Gladman's paper and C code at http://fp.gladman.plus.com/cryptography_technology/rijndael/ There are three levels of tradeoff of speed vs memory Because java has no preprocessor, they are written as three separate classes from which to choose The fastest uses 8Kbytes of static tables to precompute round calculations, 4 256 word tables for encryption and 4 for decryption. The middle performance version uses only one 256 word table for each, for a total of 2Kbytes, adding 12 rotate operations per round to compute the values contained in the other tables from the contents of the first The slowest version uses no static tables at all and computes the values in each round

This file contains the fast version with 8Kbytes of static tables for round precomputation

## Constructor Summary

Constructors
Constructor
Description
`AES()`
default constructor - 128 bit block size.

## Method Summary

Modifier and Type
Method
Description
`final String`
`getAlgorithmName()`
`final int`
`getBlockSize()`
`final void`
`init(boolean forEncryption, byte[] key)`
initialise an AES cipher.
`final int`
`processBlock(byte[] in, int inOff, byte[] out, int outOff)`
`final void`
`reset()`
`void`
`transformBlock(byte[] src, int srcoff, byte[] dst, int dstoff)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### AES

public AES()
default constructor - 128 bit block size.

## Method Details

### init

public final void init(boolean forEncryption, byte[] key)
initialise an AES cipher.

Specified by:
  `init` in interface `BlockCipher`
Parameters:
  `forEncryption` - whether or not we are for encryption.
  `key` - the key required to set up the cipher.
Throws:
  `IllegalArgumentException` - if the params argument is inappropriate.

### getAlgorithmName

public final String getAlgorithmName()

### getBlockSize

public final int getBlockSize()

Specified by:
  `getBlockSize` in interface `BlockCipher`

### processBlock

public final int processBlock(byte[] in, int inOff, byte[] out, int outOff)

### reset

public final void reset()

### transformBlock

public void transformBlock(byte[] src, int srcoff, byte[] dst, int dstoff)

Specified by:
  `transformBlock` in interface `BlockCipher`